"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createRootQueryField = createRootQueryField;
exports.createRootQueryConnection = createRootQueryConnection;

var _field = require("./field");

/* global IGraphQuillRootQuery */
function createRootQueryField(wrappedFunc, name, opts) {
  wrappedFunc.GraphQuill = function (nodeInterface) {
    var gQuillFields = {};
    gQuillFields[name] = opts;
    wrappedFunc.GraphQLFields = (0, _field.fieldMapping)(gQuillFields, nodeInterface, wrappedFunc);
    return wrappedFunc;
  };
  return wrappedFunc;
}

function createRootQueryConnection(wrappedFunc, name, opts) {
  wrappedFunc.GraphQuill = function (nodeInterface) {
    var gQuillFields = {};
    gQuillFields[name] = opts;
    wrappedFunc.GraphQLFields = (0, _field.connMapping)(gQuillFields, nodeInterface, wrappedFunc);
    return wrappedFunc;
  };
  return wrappedFunc;
}