"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createType = undefined;

var _graphql = require("graphql");

var _graphqlRelay = require("graphql-relay");

var _field = require("./field");

/* global IGraphQuillType */
function createType(wrappedClass, _ref, _fields, connections) {
  var name = _ref.name;
  var description = _ref.description;
  var resolveById = _ref.resolveById;
  var idField = _ref.idField;
  var interfaces = _ref.interfaces;

  return Object.assign(wrappedClass, {
    GraphQuill: function GraphQuill(nodeInterface) {
      var type = new _graphql.GraphQLObjectType({
        name: name,
        description: description,
        fields: function fields() {
          return Object.assign({}, { id: idField && resolveById ? (0, _graphqlRelay.globalIdField)(name, function (obj) {
              return obj[idField];
            }) : undefined }, (0, _field.fieldMapping)(_fields, nodeInterface), (0, _field.connMapping)(connections || {}, nodeInterface));
        },
        interfaces: [].concat(interfaces || [], idField && resolveById ? [nodeInterface] : [])
      });
      return Object.assign(wrappedClass, {
        GraphQLType: type,
        GraphQLConnectionType: idField && resolveById ? (0, _graphqlRelay.connectionDefinitions)({ nodeType: type }).connectionType : undefined,
        resolveById: resolveById
      });
    }
  });
}
exports.createType = createType;